"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpellingVariantsJa = void 0;
const dntShim = __importStar(require("./_dnt.shims.js"));
const mod_js_1 = require("./deps/deno.land/std@0.207.0/io/mod.js");
class SpellingVariantsJa {
    static async fetch(url, options) {
        const response = await fetch(url, options);
        const text = await response.text();
        const dict = {};
        text.trimEnd().split("\n").forEach((line) => {
            const arr = line.split(",");
            const yomi = arr[0];
            const word = arr[1];
            const surfaces = arr.slice(2);
            if (d[yomi]) {
                dict[yomi][word] = surfaces;
            }
            else {
                dict[yomi] = {};
                dict[yomi][word] = surfaces;
            }
        });
        const spellingVariantsJa = new SpellingVariantsJa();
        spellingVariantsJa.dict = dict;
        return spellingVariantsJa;
    }
    static async load(filepath, options) {
        const dict = {};
        const file = await dntShim.Deno.open(filepath, options);
        for await (const line of (0, mod_js_1.readLines)(file)) {
            const arr = line.split(",");
            const yomi = arr[0];
            const word = arr[1];
            const surfaces = arr.slice(2);
            if (dict[yomi]) {
                dict[yomi][word] = surfaces;
            }
            else {
                dict[yomi] = {};
                dict[yomi][word] = surfaces;
            }
        }
        file.close();
        const spellingVariantsJa = new SpellingVariantsJa();
        spellingVariantsJa.dict = dict;
        return spellingVariantsJa;
    }
    constructor() {
        this.dict = {};
    }
    get(word) {
        return this.dict[word];
    }
}
exports.SpellingVariantsJa = SpellingVariantsJa;
